%% PU
S_b = 2.75*10^6;
V_b = 690/sqrt(3/2);
I_b = (2/3)*S_b/(V_b);
Z_b = V_b/I_b;
omega_b = 2*pi*50;
L_b = Z_b/omega_b;
C_b = 1/(Z_b*omega_b);

V_b_dc = V_b*2;
I_b_dc = I_b*3/4;
Z_b_dc = Z_b*8/3;
C_b_dc = C_b*3/8;


T_a =4;
k_d_vsm = 40;
omega_d_vsm = 5;
%global r_s_vsm
l_s_vsm = 0.25;
r_s_vsm = 0.1;
k_pc_vsm = 1.27;
k_ic_vsm = 15;
k_ad_vsm = 1.5;
omega_ad_vsm = 50;
k_omega_vsm = 20;
k_pv_vsm = 0.29;
k_iv_vsm = 92;
omega_qf_vsm = 200;
k_q_vsm = 0.1;
k_ffv = 0;


%% sm
%sm parametre - endret til  matche sintef maskin
r_1_q=0.010024;
l_11_q=1.6117;
r_1_d=0.050477;
l_11_d=2.6734;
l_f1_d=2.3955;
r_a=0.013184;
l_ad=2.3955;
l_l=0.05450;
l_aq=1.3955;
r_f_d=0.0036817;
l_ff_d=2.5504;
l_lf_d =l_ff_d-l_ad;
l_1_d = l_11_d-l_ad;
l_1_q = l_11_q-l_aq;

T_sm = 1.7;                                
k_d_sm = 0;
T_gt = 0.5;
T_ex = 0.1;

k_p_ex =13.3*r_f_d/l_ad;
k_i_ex =38.6*r_f_d /l_ad; 
k_omega_sm = 15;
omega_f_sm = 1000;
k_q_sm = 0.2;

c_mg = 5*10^-2;
C_mg = c_mg*C_b;
l_mg = 0.05;
L_mg = l_mg*L_b;
r_mg = 0.1;
R_mg = r_mg*Z_b;

C_l = 1*10^-5;
c_l =C_l/C_b;
R_l = 0.5;
r_l = R_l/Z_b;
%% Last parametere 
C_dc = 12000*10^-6; 
c_dc= C_dc/C_b_dc;

l_f = 0.08;
L_f = l_f*L_b;
r_f = 0.003;
R_f = Z_b*r_f;
c_f = 0.074;
C_f = c_f*C_b;

r_g = 0.005;
R_g = r_g*Z_b;
l_g = 0.2;
L_g = l_g*L_b;
omega_f =500;
omega_ad = 50;
omega_lp_pll = 500;

k_ffv = 0;
% trenger ny verdi, m tunes eller beregnes
k_p_pll =0.084;
k_i_pll = 4.69;
k_p_dc = 0.81;
k_i_dc = 166.67;
k_pc = 1.27;
k_ic = 11.78;
k_ad_l = 1.5;
%% Variables
% X
syms  v0_d_vsm v0_q_vsm icv_d_vsm icv_q_vsm gamma_d_vsm gamma_q_vsm i0_d_vsm i0_q_vsm phi_d_vsm phi_q_vsm zeta_vsm is_d_vsm is_q_vsm q_m_vsm omega_vsm kappa_vsm;
syms v0_d v0_q icv_d icv_q gamma_d gamma_q i0_d i0_q phi_d phi_q v_pll_d v_pll_q epsi delta_theta_pll  v_g_d v_g_q;
syms v_sm_d v_sm_q i0_sm_d i0_sm_q i_sm_d i_sm_q i_f_d i_1_d i_1_q omega_sm delta_theta_sm p_m_sm q_m_sm zeta_sm v_f_d rho p_m;
% U
syms p_star icv_d_star icv_q_star omega_b;
syms  p_star_vsm q_star_vsm v_hat_star_vsm omega_star_vsm;
syms v_hat_g_d v_hat_g_q p_sm_star q_m_sm_star omega_sm_star v_hat_sm_star;

v_e = sqrt((v0_d_vsm^2)+v0_q_vsm^2);
p = (v0_d_vsm*i0_d_vsm+v0_q_vsm*i0_q_vsm);
q = (i0_d_vsm*v0_q_vsm-v0_d_vsm*i0_q_vsm);

omega_pll_n = 1;
omega_pll = (k_p_pll*atan(v_pll_q/v_pll_d)+k_i_pll*epsi+omega_pll_n);
v_cv_d=k_pc*(icv_d_star - icv_d) + k_ic*gamma_d - l_f*icv_q*omega_pll - k_ad_l*v0_d + k_ad_l*phi_d;
v_cv_q=k_pc*(icv_q_star - icv_q) + k_ic*gamma_q + l_f*icv_d*omega_pll - k_ad_l*v0_q + k_ad_l*phi_q;




%% System equations
%% vsm
eq1 =  omega_b*omega_vsm*v0_q_vsm + (omega_b*icv_d_vsm)/c_f - (omega_b*i0_d_vsm)/c_f;
eq2 = -omega_b*omega_vsm*v0_d_vsm + (omega_b*icv_q_vsm)/c_f - (omega_b*i0_q_vsm)/c_f;

eq3 = -(omega_b*(1-k_ffv+k_ad_vsm)*v0_d_vsm)/l_f - (omega_b*(k_pc_vsm+r_f)*icv_d_vsm)/l_f + omega_b*k_ic_vsm*gamma_d_vsm/l_f - omega_b*k_ad_vsm*phi_d_vsm/l_f + omega_b*k_pc_vsm*is_d_vsm/l_f;
eq4 = -(omega_b*(1-k_ffv+k_ad_vsm)*v0_q_vsm)/l_f - (omega_b*(k_pc_vsm+r_f)*icv_q_vsm)/l_f + omega_b*k_ic_vsm*gamma_q_vsm/l_f - omega_b*k_ad_vsm*phi_q_vsm/l_f + omega_b*k_pc_vsm*is_q_vsm/l_f;

eq5 = -icv_d_vsm + is_d_vsm;
eq6 = -icv_q_vsm + is_q_vsm;

eq7 = omega_b*v0_d_vsm/l_g-omega_b*r_g*i0_d_vsm/l_g+omega_b*omega_vsm*i0_q_vsm-omega_b*v_g_d/l_g;
eq8 = omega_b*v0_q_vsm/l_g-omega_b*r_g*i0_q_vsm/l_g-omega_b*omega_vsm*i0_d_vsm-omega_b*v_g_q/l_g;

eq9 =  -omega_ad_vsm*v0_d_vsm - omega_ad_vsm*phi_d_vsm;
eq10 = -omega_ad_vsm*v0_q_vsm - omega_ad_vsm*phi_q_vsm;

eq11 = -v_e - k_q_vsm*q_m_vsm + k_q_vsm*q_star_vsm + v_hat_star_vsm;

eq12 = -(omega_b*v0_d_vsm)/l_s_vsm - omega_b*k_pv_vsm*v_e/l_s_vsm + (omega_b*k_iv_vsm*zeta_vsm)/l_s_vsm - (omega_b*r_s_vsm*is_d_vsm)/l_s_vsm + omega_b*omega_vsm*is_q_vsm -(omega_b*k_pv_vsm*k_q_vsm*q_m_vsm)/l_s_vsm+(omega_b*k_pv_vsm*k_q_vsm*q_star_vsm)/l_s_vsm + (omega_b*k_pv_vsm*v_hat_star_vsm)/l_s_vsm;
eq13 = -(omega_b*v0_q_vsm)/l_s_vsm - omega_b*r_s_vsm*is_q_vsm/l_s_vsm - omega_b*omega_vsm*is_d_vsm;

eq14 = -i0_q_vsm*v0_d_vsm*omega_qf_vsm + i0_d_vsm*v0_q_vsm*omega_qf_vsm - q_m_vsm*omega_qf_vsm;

eq15 = -p/T_a -((k_d_vsm + k_omega_vsm)*omega_vsm)/T_a + (k_d_vsm*kappa_vsm)/T_a+ p_star_vsm/T_a+(k_omega_vsm*omega_star_vsm)/T_a;
eq16 = omega_d_vsm*omega_vsm - kappa_vsm*omega_d_vsm;

%% load
eq17 = omega_b*omega_vsm*v0_q + omega_b*icv_d/c_f - omega_b*i0_d/c_f;
eq18 =-omega_b*omega_vsm*v0_d + omega_b*icv_q/c_f - omega_b*i0_q/c_f;

eq19 = (omega_b/l_f)*(v_cv_d-r_f*icv_d-v0_d+l_f*icv_q*omega_vsm);
eq20 = (omega_b/l_f)*(v_cv_q-r_f*icv_q-v0_q-l_f*icv_d*omega_vsm);

eq21 =-icv_d+icv_d_star;
eq22 =-icv_q+icv_q_star;

eq23 = omega_b*v0_d/l_g - omega_b*r_g*i0_d/l_g + omega_b*omega_vsm*i0_q - omega_b*v_g_d*cos(delta_theta_pll)/l_g - omega_b*v_g_q*sin(delta_theta_pll)/l_g;
eq24 = omega_b*v0_q/l_g - omega_b*r_g*i0_q/l_g - omega_b*omega_vsm*i0_d + omega_b*v_g_d*sin(delta_theta_pll)/l_g - omega_b*v_g_q*cos(delta_theta_pll)/l_g;

eq25 =  omega_ad*v0_d - omega_ad*phi_d;
eq26 = omega_ad*v0_q - omega_ad*phi_q;

eq27 = omega_lp_pll*v0_d-omega_lp_pll*v_pll_d;
eq28 = omega_lp_pll*v0_q-omega_lp_pll*v_pll_q;

eq29 = atan(v_pll_q/v_pll_d);
eq30 = -omega_b*omega_vsm + omega_b*omega_pll;

eq31 = + omega_b*omega_vsm*v_g_q - omega_b*v_g_d/(c_l*r_l) + omega_b*i0_d_vsm/c_l + omega_b*i0_d*cos(delta_theta_pll)/c_l - omega_b*i0_q*sin(delta_theta_pll)/c_l + omega_b*i0_sm_d*cos(delta_theta_sm)/c_l - omega_b*i0_sm_q*sin(delta_theta_sm)/c_l;
eq32 = - omega_b*omega_vsm*v_g_d - omega_b*v_g_q/(c_l*r_l) + omega_b*i0_q_vsm/c_l + omega_b*i0_d*sin(delta_theta_pll)/c_l + omega_b*i0_q*cos(delta_theta_pll)/c_l + omega_b*i0_sm_d*sin(delta_theta_sm)/c_l + omega_b*i0_sm_q*cos(delta_theta_sm)/c_l;

%% sm
eq33 =  omega_b*omega_vsm*v_sm_q - omega_b*i0_sm_d/c_mg + omega_b*i_sm_d/c_mg;
eq34 = -omega_b*omega_vsm*v_sm_d - omega_b*i0_sm_q/c_mg + omega_b*i_sm_q/c_mg;

eq35 = omega_b*v_sm_d/l_mg + omega_b*omega_vsm*i0_sm_q - omega_b*r_mg*i0_sm_d/l_mg - omega_b*v_g_d*cos(delta_theta_sm)/l_mg - omega_b*v_g_q*sin(delta_theta_sm)/l_mg;
eq36 = omega_b*v_sm_q/l_mg - omega_b*omega_vsm*i0_sm_d - omega_b*r_mg*i0_sm_q/l_mg + omega_b*v_g_d*sin(delta_theta_sm)/l_mg - omega_b*v_g_q*cos(delta_theta_sm)/l_mg;

eq37=(l_11_d*l_ff_d - l_f1_d^2)*omega_b*r_a*i_sm_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_11_d*l_ff_d - l_f1_d^2)*omega_b*omega_sm*(l_aq + l_l)*i_sm_q/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_11_d - l_f1_d)*l_ad*omega_b*r_f_d*i_f_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_f1_d - l_ff_d)*l_ad*omega_b*r_1_d*i_1_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_11_d*l_ff_d - l_f1_d^2)*omega_b*omega_sm*l_aq*i_1_q/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_11_d*l_ff_d - l_f1_d^2)*omega_b*v_sm_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_11_d - l_f1_d)*l_ad*omega_b*v_f_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l);
eq38=-l_11_q*omega_b*omega_sm*(l_ad + l_l)*i_sm_d/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) - l_11_q*omega_b*r_a*i_sm_q/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) + l_11_q*omega_b*omega_sm*l_ad*i_f_d/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) + l_11_q*omega_b*omega_sm*l_ad*i_1_d/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) - l_aq*omega_b*r_1_q*i_1_q/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) - l_11_q*omega_b*v_sm_q/(l_11_q*l_aq + l_11_q*l_l - l_aq^2);
eq39=(l_11_d - l_f1_d)*l_ad*omega_b*r_a*i_sm_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_11_d - l_f1_d)*l_ad*omega_b*omega_sm*(l_aq + l_l)*i_sm_q/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_11_d*l_ad + l_11_d*l_l - l_ad^2)*omega_b*r_f_d*i_f_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_ad^2 - l_ad*l_f1_d - l_f1_d*l_l)*omega_b*r_1_d*i_1_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_11_d - l_f1_d)*l_ad*omega_b*omega_sm*l_aq*i_1_q/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_11_d - l_f1_d)*l_ad*omega_b*v_sm_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_11_d*l_ad + l_11_d*l_l - l_ad^2)*omega_b*v_f_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l);
eq40=-(l_f1_d - l_ff_d)*l_ad*omega_b*r_a*i_sm_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_f1_d - l_ff_d)*l_ad*omega_b*omega_sm*(l_aq + l_l)*i_sm_q/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) + (l_ad^2 - l_ad*l_f1_d - l_f1_d*l_l)*omega_b*r_f_d*i_f_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_ad^2 - l_ad*l_ff_d - l_ff_d*l_l)*omega_b*r_1_d*i_1_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_f1_d - l_ff_d)*l_ad*omega_b*omega_sm*l_aq*i_1_q/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_f1_d - l_ff_d)*l_ad*omega_b*v_sm_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l) - (l_ad^2 - l_ad*l_f1_d - l_f1_d*l_l)*omega_b*v_f_d/(l_11_d*l_ad^2 - l_11_d*l_ad*l_ff_d - l_11_d*l_ff_d*l_l - 2*l_ad^2*l_f1_d + l_ad^2*l_ff_d + l_ad*l_f1_d^2 + l_f1_d^2*l_l);
eq41=-l_aq*omega_b*omega_sm*(l_ad + l_l)*i_sm_d/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) - l_aq*omega_b*r_a*i_sm_q/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) + l_aq*omega_b*omega_sm*l_ad*i_f_d/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) + l_aq*omega_b*omega_sm*l_ad*i_1_d/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) - (l_aq + l_l)*omega_b*r_1_q*i_1_q/(l_11_q*l_aq + l_11_q*l_l - l_aq^2) - l_aq*omega_b*v_sm_q/(l_11_q*l_aq + l_11_q*l_l - l_aq^2);
eq42=(l_ad-l_aq)*i_sm_d*i_sm_q/T_sm+l_aq*i_1_q*i_sm_d/T_sm-l_ad*i_f_d*i_sm_q/T_sm-l_ad*i_1_d*i_sm_q/T_sm-k_d_sm*omega_sm/T_sm+k_d_sm*omega_sm/T_sm+p_m_sm/(omega_sm*T_sm);
eq43= omega_b*omega_sm-omega_b*omega_vsm;

eq44 = -k_omega_sm*omega_sm/T_gt - p_m_sm/T_gt + p_sm_star/T_gt + k_omega_sm*omega_sm_star/T_gt;
eq45 = omega_f_sm*(-v_sm_d*i_sm_q+v_sm_q*i_sm_d)-omega_f_sm*q_m_sm;


eq46 = -sqrt((v_sm_d^2)+(v_sm_q^2)) - k_q_sm*q_m_sm + k_q_sm*q_m_sm_star + v_hat_sm_star;
eq47 = -k_p_ex*sqrt((v_sm_d)^2+(v_sm_q)^2)/T_ex...
    - k_p_ex*k_q_sm*q_m_sm/T_ex+ k_i_ex*zeta_sm/T_ex...
    - v_f_d/T_ex + k_p_ex*k_q_sm*q_m_sm_star/T_ex + k_p_ex*v_hat_sm_star/T_ex;


%% setup matrix
eq_matrix = [eq1;eq2;eq3;eq4;eq5;eq6;eq7;eq8;eq9;eq10;eq11;eq12;eq13;eq14;eq15;eq16;eq17;eq18;eq19;eq20;eq21;eq22;eq23;eq24;eq25;...
 eq26;eq27;eq28;eq29;eq30;eq31;eq32;eq33;eq34;eq35;eq36;eq37;eq38;eq39;eq40;eq41;eq42;eq43;eq44;eq45;eq46;eq47;];%

A = jacobian(eq_matrix, [v0_d_vsm v0_q_vsm icv_d_vsm icv_q_vsm gamma_d_vsm gamma_q_vsm i0_d_vsm i0_q_vsm phi_d_vsm phi_q_vsm zeta_vsm is_d_vsm is_q_vsm q_m_vsm omega_vsm kappa_vsm...
                          v0_d v0_q icv_d icv_q gamma_d gamma_q i0_d i0_q phi_d phi_q v_pll_d v_pll_q epsi delta_theta_pll v_g_d v_g_q ...
                          v_sm_d v_sm_q i0_sm_d i0_sm_q i_sm_d i_sm_q i_f_d i_1_d i_1_q omega_sm delta_theta_sm p_m_sm q_m_sm zeta_sm v_f_d]);
B = jacobian(eq_matrix, [icv_d_star icv_q_star p_star_vsm q_star_vsm v_hat_star_vsm omega_star_vsm p_sm_star q_m_sm_star omega_sm_star v_hat_sm_star]);

C = eye(47);
D = zeros(47,10);

%% Using fsolve
v_g_d0 = 1;
v_g_q0 = 0;
v_sm_d0 = 1;
v_sm_q0= 0;
i0_sm_d0= 0;
i0_sm_q0= 0;
i_sm_d0= 0;
i_sm_q0= 0;
i_f_d0= 0;
i_1_d0= 0;
i_1_q0= 0;
omega_sm0= 1;
delta_theta_sm0 = 0;
p_m_sm0= 0;
q_m_sm0 = 0;
zeta_sm0 = 0;
v_f_d0 = 0;

v0_d_vsm0 =1;
v0_q_vsm0= 0;
icv_d_vsm0=0;
icv_q_vsm0=0;
gamma_d_vsm0=0;
gamma_q_vsm0=0;
i0_d_vsm0=0;
i0_q_vsm0=0;
phi_d_vsm0=0;
phi_q_vsm0=0;
zeta_vsm0=0;
is_d_vsm0=0;
is_q_vsm0=0;
q_m_vsm0=0;
omega_vsm0=1;
kappa_vsm0=0;

v0_d0 = 1;
v0_q0 =0;
icv_d0 =0;
icv_q0=0; 
gamma_d0=0; 
gamma_q0=0;
i0_d0=0; 
i0_q0=0;
phi_d0=0; 
phi_q0=0; 
v_pll_d0=1; 
v_pll_q0=0;
epsi0=0;
delta_theta_pll0=0;



x_init_solve_sm = [v0_d_vsm0 v0_q_vsm0 icv_d_vsm0 icv_q_vsm0 gamma_d_vsm0 gamma_q_vsm0 i0_d_vsm0 i0_q_vsm0 phi_d_vsm0 phi_q_vsm0 zeta_vsm0 is_d_vsm0 is_q_vsm0 q_m_vsm0 omega_vsm0 kappa_vsm0...
v0_d0 v0_q0 icv_d0 icv_q0 gamma_d0 gamma_q0 i0_d0 i0_q0 phi_d0 phi_q0 v_pll_d0 v_pll_q0 epsi0 delta_theta_pll0 v_g_d0 v_g_q0 ...
v_sm_d0 v_sm_q0 i0_sm_d0 i0_sm_q0 i_sm_d0 i_sm_q0 i_f_d0 i_1_d0 i_1_q0 omega_sm0 delta_theta_sm0 p_m_sm0 q_m_sm0 zeta_sm0 v_f_d0]';
options = optimoptions('fsolve','Display','iter','MaxFunEvals',70000000, 'MaxIterations', 70000000);
[x0,fval] = fsolve(@funksjon_full_system_model,x_init_solve_sm,options);

%% Setting up linearized system
icv_d_star = -1;
p_sm_star = 0.5;
q_m_sm_star = 0;
omega_sm_star = 1;
v_hat_sm_star = 1;

p_star_vsm = 0.5;
q_star_vsm = 0.2;
v_hat_star_vsm = 1;
omega_star_vsm = 1;
icv_q_star = 0;


v0_d_vsm=x0(1);
v0_q_vsm=x0(2);
icv_d_vsm=x0(3);
icv_q_vsm=x0(4);
gamma_d_vsm=x0(5);
gamma_q_vsm=x0(6);
i0_d_vsm=x0(7);
i0_q_vsm=x0(8);
phi_d_vsm=x0(9);
phi_q_vsm=x0(10);
zeta_vsm=x0(11);
is_d_vsm=x0(12);
is_q_vsm=x0(13);
q_m_vsm=x0(14);


omega_vsm=x0(15);
kappa_vsm=x0(16);
v0_d=x0(17);
v0_q=x0(18);
icv_d=x0(19);
icv_q=x0(20);
gamma_d=x0(21);
gamma_q=x0(22);
i0_d=x0(23);
i0_q=x0(24);
phi_d=x0(25);
phi_q=x0(26);
v_pll_d=x0(27);
v_pll_q=x0(28);
epsi=x0(29);
delta_theta_pll=x0(30);
v_g_d = x0(31);
v_g_q =x0(32);


v_sm_d=x0(33);
v_sm_q=x0(34);
i0_sm_d=x0(35);
i0_sm_q=x0(36);
i_sm_d=x0(37);
i_sm_q=x0(38);
i_f_d=x0(39);
i_1_d=x0(40);
i_1_q=x0(41);
omega_sm=x0(42);
delta_theta_sm = x0(43);
p_m_sm=x0(44);
q_m_sm=x0(45);
zeta_sm=x0(46);
v_f_d=x0(47);

%% calcualating eigenvalues
A_lin = eval(A);
B_lin = eval(B);
eigen = eig(A_lin);

plot(eigen,'o')
grid on


pole_number = size(A,1);

end








